#ifndef COM_PORT_H
#define COM_PORT_H
//*********************************************************************************************************************


#include <QObject>
#include <QSerialPort>
#include "SettingsDialogComPort.hpp"
//*********************************************************************************************************************


#define HEADER_H            0xAA
#define HEADER_L            0x55
#define READ_BUFFER_SIZE    32

#define DEBUG_ARRAY_TX      false //true //
#define DEBUG_ARRAY_RX_1    false //true //
#define DEBUG_ARRAY_RX_2    false //true //
#define DEBUG_COM_PORT      false //true //
//*********************************************************************************************************************


class ComPort : public QObject
{
    Q_OBJECT
public:
    explicit ComPort(QObject *parent = nullptr);
    ~ComPort();
    void OpenPort(void);
    void ClosePort(void);
    void OpenSettingsDialogComPort(void);
    quint16 CalcCRC16 (QByteArray *, quint16);

    QByteArray dataRX;
    QSerialPort *serialPort;
    SettingsDialogComPort *selectPort;

public slots:
    void WriteData(QByteArray data);

signals:
    void RecivePacketSignal(QByteArray data);
    void PortConnectStateSignal(bool);
    void SendDataToDecodeSignal(QByteArray data);
    void finishedPort(void);

private slots:

private:
    void RecivePacket(void);
};
//*********************************************************************************************************************


#endif // COM_PORT_H
//*********************************************************************************************************************


